class LCBindScanner expands Actor;

var byte CurIdx;
var PlayerPawn LocalPlayer;

auto state Scanning
{
Begin:
	While ( LocalPlayer == none )
	{
		FindLocal();
		Sleep(0.1);
	}
	if ( LocalPlayer.IsA('bbPlayer') )
	{
		Destroy();
		Stop;
	}
	While ( CurIdX != 255 )
	{
		AnalyseBind( CurIdx);
		CurIdx++;
		Sleep(0);
	}
	Destroy();
}


function AnalyseBind( byte Idx)
{
	local string KeyName, KeyBind, Parms, Processed, Saved[16];
	local bool bSave, bAppend;
	local byte bEdited;
	local int i, j, k;

	KeyName = LocalPlayer.ConsoleCommand("KeyName "$ Idx);
	KeyBind = LocalPlayer.ConsoleCommand("KeyBinding "$ KeyName);
	//Weapon bind here
	if ( InStr(CAPS(KeyBind), "WEAPON") >= 0 )
	{
//		LocalPlayer.ClientMessage("Found Weapon bind: "$ KeyBind $ " on " $ KeyName );
		While ( KeyBind != "" ) //Dissasemble Bind
			Saved[j++] = class'LCStatics'.static.NextParameter( KeyBind, "|");
		For ( i=0 ; i<j ; i++ )
		{
			Parms = GetTheWord( Saved[i]);
			if ( Parms ~= "GetWeapon" )
			{
				Processed = MutatedVersion( GetTheWord2( Saved[i]) );
//				LocalPlayer.ClientMessage(">> Processing "$ Saved[i] $ " >> "$ Processed );
				if ( Processed == "" )
					continue;
				bAppend = true;
				For ( k=0 ; k<j ; k++ )
				{
					if ( (GetTheWord(Saved[k]) ~= "Mutate") && (GetTheWord2(Saved[k]) ~= "GetWeapon") && (GetTheWord3(Saved[k]) ~= Processed) )
					{
						bAppend = false;
						break;
					}
				}
				if ( !bAppend )
					continue;
				bSave = true;
				For ( k=j ; k>i ; k-- )
					Saved[k] = Saved[k-1];
				j++;
				Saved[i++] = "Mutate GetWeapon "$Processed;
			}
		}		
		if ( bSave )
		{
			For ( i=0 ; i<j ; i++ )
				KeyBind = KeyBind $ "|" $ Saved[i];
			KeyBind = Mid(KeyBind,1);
			LocalPlayer.ConsoleCommand("Set Input"@ KeyName @ KeyBind);
		}
	}
}


simulated function ProcessBinds( PlayerPawn LocalPlayer)
{
	local int i;
	local string KeyName, KeyBind, Parms, Processed;
	local bool bSave;
	local byte bEdited;

	if ( LocalPlayer == none )
		return;
	LocalPlayer.ClientMessage("Correcting binds...");
	i = 1;
	While ( i < 254 )
	{
		KeyName = LocalPlayer.ConsoleCommand("KeyName "$ i);
		KeyBind = LocalPlayer.ConsoleCommand("KeyBinding "$ KeyName);


		//This is a weapon bind
		if ( InStr(CAPS(KeyBind),"WEAPON") >= 0 )
		{
			Parms = KeyBind;
			KeyBind = "";
			While ( Parms != "" )
			{
				Processed = class'LCStatics'.static.NextParameter( Parms, "|");
				if ( GetTheWord( Processed) ~= "GetWeapon" )
					Processed = ProcessGetWeapon( Processed, bEdited);

				if ( !bSave && bEdited > 0 )
					bSave = true;
				KeyBind = KeyBind $ "|" $ Processed;
			}
			KeyBind = Mid(KeyBind,1); //Remove first |
		}

		if ( bSave )
		{
			LocalPlayer.ConsoleCommand("Set Input"@ KeyName @ KeyBind);
			LocalPlayer.ClientMessage("Altered bind "$KeyName$" to: "$KeyBind);
			bSave = False;
			bEdited = 0;
		}
		i++;
	}
}

simulated function string ProcessGetWeapon( string Cmd, out byte bEdited)
{
	local string command;
	local string VersionString;
	local bool bOldEdited;

	Command = Class.static.GetTheWord2(Cmd);
	if ( (InStr(Command,".") > 0) && (Left(Command,5) ~= "siege") )
	{
		Command = Mid( Command, InStr(Command,".")+1);
		VersionString = string(class);
		VersionString = Left( VersionString, InStr(VersionString,".")+1);
	}

	bEdited = 1;

	if ( Command ~= "SniperRifle" || Command ~= "zp_SniperRifle" )
		return "GetWeapon SniperRifle|mutate getweapon zp_sn";
	else if ( Command ~= "ShockRifle" || Command ~= "zp_ShockRifle" )
		return "GetWeapon ShockRifle|mutate getweapon zp_sh";
	else if ( Command ~= "Enforcer" || Command ~= "sgEnforcer" )
		return "GetWeapon Enforcer|mutate getweapon zp_e";
	else if ( Command ~= "sgTranslocator" )
		return "GetWeapon"@VersionString$"sgTranslocator";
	else if ( Command ~= "sgNukeLauncher" )
	{
		if ( VersionString != "" )
			return "GetNuke";
	}
	else if ( Command ~= "sgConstructor" )
	{
		if ( VersionString != "" )
			return "GetConstructor";
	}
	bEdited = 0;
	return Cmd;
}


function string MutatedVersion( string WeapName)
{
	if ( InStr(Caps(WeapName),"SNIPERRIFLE") >= 0 )
		return "zp_sn";
	if ( InStr(Caps(WeapName),"SHOCKRIFLE") >= 0 )
		return "zp_sh";
	if ( InStr(Caps(WeapName),"ENFORCER") >= 0 )
		return "zp_e";
	if ( InStr(Caps(WeapName),"ASMDPULSERIFLE") >= 0 )
		return "lc_apr";
	if ( InStr(Caps(WeapName),"MINIGUN") >= 0 )
		return "lc_m";
	if ( InStr(Caps(WeapName),"SIEGEINSTAGIBRIFLE") >= 0 )
		return "lc_sir";
}

function FindLocal()
{
	local PlayerPawn P;

	ForEach AllActors (class'PlayerPawn', P)
	{
		if ( ViewPort(P.Player) != none )
		{
			LocalPlayer = P;
			return;
		}
	}
}


static function ClearSpaces(out string Text)
{
	while ( InStr(Text," ") == 0 )
		Text = Mid(Text,1);
}
static function string GetTheWord(string Text)
{
	local int i;
	ClearSpaces(Text);
	i = InStr( Text, " ");
	if ( i < 0 )
		return Text;
	return Left(Text,i);
}
static function string GetTheWord2( string Text)
{
	local int i;

	ClearSpaces(Text);
	i = InStr( Text, " ");
	if ( i < 0 )
		return "";
	Text = Mid( Text, i);
	ClearSpaces(Text);
	return GetTheWord(Text);
}
static function string GetTheWord3( string Text)
{
	local int i;

	ClearSpaces(Text);
	i = InStr( Text, " ");
	if ( i < 0 )
		return "";
	Text = Mid( Text, i);
	ClearSpaces(Text);
	return GetTheWord2(Text);
}

defaultproperties
{
	bNetTemporary=False
	bHidden=True
	bAlwaysRelevant=False
	NetPriority=2
	LifeSpan=50
	RemoteRole=ROLE_None
	CurIdx=1
}